from lib2to3.tests.test_fixers import FixerTestCase as lib2to3FixerTestCase


class FixerTestCase(lib2to3FixerTestCase):
  # Subclass to replace "fixer_pkg"
  def setUp(self, fix_list=None, fixer_pkg="my2to3", options=None):
    super(FixerTestCase, self).setUp(fix_list, fixer_pkg, options)

    if self.fixer.endswith('_trace'):
      fix_name = 'fix_' + self.fixer
      self.fixer_module = fixer_module = getattr(__import__('my2to3.fixes', fromlist=[fix_name]), fix_name)

      self.traces = []
      # Wrap fixer_module.trace, to populate self.traces
      self.old_insert_trace = fixer_module.insert_trace
      def decorate(func):
        def call(*args):
          self.traces.append(args)
          return func(*args)
        return call
      fixer_module.insert_trace = decorate(fixer_module.insert_trace)

  def tearDown(self, *args, **kw):
    super(FixerTestCase, self).tearDown(*args, **kw)

    if self.fixer.endswith('_trace'):
      self.fixer_module.insert_trace = self.old_insert_trace
